# The Ubiquitous Binary Search | Set 1

We all aware of binary search algorithm. Binary search is easiest difficult algorithm to get it right. I present some interesting problems that I collected on binary search. There were some requests on binary search.

**I request you to honor the code, “I sincerely attempt to solve the problem and ensure there are no corner cases”. After reading each problem minimize the browser and try solving it.**

**Problem Statement:** Given a sorted array of N distinct elements. Find a key in the array using least number of comparisons. (Do you think binary search is optimal to search a key in sorted array?)

Without much theory, here is typical binary search algorithm.

`// Returns location of key, or -1 if not found ` `int` `BinarySearch(` `int` `A[], ` `int` `l, ` `int` `r, ` `int` `key) ` `{ ` ` ` `int` `m; ` ` ` ` ` `while` `( l <= r ) ` ` ` `{ ` ` ` `m = l + (r-l)/2; ` ` ` ` ` `if` `( A[m] == key ) ` `// first comparison ` ` ` `return` `m; ` ` ` ` ` `if` `( A[m] < key ) ` `// second comparison ` ` ` `l = m + 1; ` ` ` `else` ` ` `r = m - 1; ` ` ` `} ` ` ` ` ` `return` `-1; ` `} ` |

*chevron_right*

*filter_none*

Theoretically we need *log N + 1* comparisons in worst case. If we observe, we are using two comparisons per iteration except during final successful match, if any. In practice, comparison would be costly operation, it won’t be just primitive type comparison. It is more economical to minimize comparisons as that of theoretical limit.

See below figure on initialize of indices in the next implementation.

The following implementation uses fewer number of comparisons.

`// Invariant: A[l] <= key and A[r] > key ` `// Boundary: |r - l| = 1 ` `// Input: A[l .... r-1] ` `int` `BinarySearch(` `int` `A[], ` `int` `l, ` `int` `r, ` `int` `key) ` `{ ` ` ` `int` `m; ` ` ` ` ` `while` `( r - l > 1 ) ` ` ` `{ ` ` ` `m = l + (r-l)/2; ` ` ` ` ` `if` `( A[m] <= key ) ` ` ` `l = m; ` ` ` `else` ` ` `r = m; ` ` ` `} ` ` ` ` ` `if` `( A[l] == key ) ` ` ` `return` `l; ` ` ` `if` `( A[r] == key ) ` ` ` `return` `r; ` ` ` `else` ` ` `return` `-1; ` `} ` |

*chevron_right*

*filter_none*

In the while loop we are depending only on one comparison. The search space converges to place *l* and *r* point two different consecutive elements. We need one more comparison to trace search status.

You can see sample test case http://ideone.com/76bad0. (*C++11 code*)

**Problem Statement:** Given an array of N distinct integers, find floor value of input ‘key’. Say, A = {-1, 2, 3, 5, 6, 8, 9, 10} and key = 7, we should return 6 as outcome.

We can use the above optimized implementation to find floor value of key. We keep moving the left pointer to right most as long as the invariant holds. Eventually left pointer points an element less than or equal to key (by definition floor value). The following are possible corner cases,

—> If all elements in the array are smaller than key, left pointer moves till last element.

—> If all elements in the array are greater than key, it is an error condition.

—> If all elements in the array equal and <= key, it is worst case input to our implementation.

Here is implementation,

`// largest value <= key ` `// Invariant: A[l] <= key and A[r] > key ` `// Boundary: |r - l| = 1 ` `// Input: A[l .... r-1] ` `// Precondition: A[l] <= key <= A[r] ` `int` `Floor(` `int` `A[], ` `int` `l, ` `int` `r, ` `int` `key) ` `{ ` ` ` `int` `m; ` ` ` ` ` `while` `( r - l > 1 ) ` ` ` `{ ` ` ` `m = l + (r - l)/2; ` ` ` ` ` `if` `( A[m] <= key ) ` ` ` `l = m; ` ` ` `else` ` ` `r = m; ` ` ` `} ` ` ` ` ` `return` `A[l]; ` `} ` ` ` `// Initial call ` `int` `Floor(` `int` `A[], ` `int` `size, ` `int` `key) ` `{ ` ` ` `// Add error checking if key < A[0] ` ` ` `if` `( key < A[0] ) ` ` ` `return` `-1; ` ` ` ` ` `// Observe boundaries ` ` ` `return` `Floor(A, 0, size, key); ` `} ` |

*chevron_right*

*filter_none*

You can see some test cases http://ideone.com/z0Kx4a.

**Problem Statement:** Given a sorted array with possible duplicate elements. Find number of occurrences of input ‘key’ in *log N* time.

The idea here is finding left and right most occurrences of key in the array using binary search. We can modify floor function to trace right most occurrence and left most occurrence. Here is implementation,

`// Input: Indices Range [l ... r) ` `// Invariant: A[l] <= key and A[r] > key ` `int` `GetRightPosition(` `int` `A[], ` `int` `l, ` `int` `r, ` `int` `key) ` `{ ` ` ` `int` `m; ` ` ` ` ` `while` `( r - l > 1 ) ` ` ` `{ ` ` ` `m = l + (r - l)/2; ` ` ` ` ` `if` `( A[m] <= key ) ` ` ` `l = m; ` ` ` `else` ` ` `r = m; ` ` ` `} ` ` ` ` ` `return` `l; ` `} ` ` ` `// Input: Indices Range (l ... r] ` `// Invariant: A[r] >= key and A[l] > key ` `int` `GetLeftPosition(` `int` `A[], ` `int` `l, ` `int` `r, ` `int` `key) ` `{ ` ` ` `int` `m; ` ` ` ` ` `while` `( r - l > 1 ) ` ` ` `{ ` ` ` `m = l + (r - l)/2; ` ` ` ` ` `if` `( A[m] >= key ) ` ` ` `r = m; ` ` ` `else` ` ` `l = m; ` ` ` `} ` ` ` ` ` `return` `r; ` `} ` ` ` `int` `CountOccurances(` `int` `A[], ` `int` `size, ` `int` `key) ` `{ ` ` ` `// Observe boundary conditions ` ` ` `int` `left = GetLeftPosition(A, -1, size-1, key); ` ` ` `int` `right = GetRightPosition(A, 0, size, key); ` ` ` ` ` `// What if the element doesn't exists in the array? ` ` ` `// The checks helps to trace that element exists ` ` ` `return` `(A[left] == key && key == A[right])? ` ` ` `(right - left + 1) : 0; ` `} ` |

*chevron_right*

*filter_none*

Sample code http://ideone.com/zn6R6a.

**Problem Statement:** Given a sorted array of distinct elements, and the array is rotated at an unknown position. Find minimum element in the array.

We can see pictorial representation of sample input array in the below figure.

We converge the search space till *l* and *r* points single element. If the middle location falls in the first pulse, the condition A[m] < A[r] doesn’t satisfy, we converge our search space to A[m+1 … r]. If the middle location falls in the second pulse, the condition A[m] < A[r] satisfied, we converge our search space to A[1 … m]. At every iteration we check for search space size, if it is 1, we are done.

Given below is implementation of algorithm. *Can you come up with different implementation?*

`int` `BinarySearchIndexOfMinimumRotatedArray(` `int` `A[], ` `int` `l, ` `int` `r) ` `{ ` ` ` `// extreme condition, size zero or size two ` ` ` `int` `m; ` ` ` ` ` `// Precondition: A[l] > A[r] ` ` ` `if` `( A[l] <= A[r] ) ` ` ` `return` `l; ` ` ` ` ` `while` `( l <= r ) ` ` ` `{ ` ` ` `// Termination condition (l will eventually falls on r, and r always ` ` ` `// point minimum possible value) ` ` ` `if` `( l == r ) ` ` ` `return` `l; ` ` ` ` ` `m = l + (r-l)/2; ` `// 'm' can fall in first pulse, ` ` ` `// second pulse or exactly in the middle ` ` ` ` ` `if` `( A[m] < A[r] ) ` ` ` `// min can't be in the range ` ` ` `// (m < i <= r), we can exclude A[m+1 ... r] ` ` ` `r = m; ` ` ` `else` ` ` `// min must be in the range (m < i <= r), ` ` ` `// we must search in A[m+1 ... r] ` ` ` `l = m+1; ` ` ` `} ` ` ` ` ` `return` `-1; ` `} ` ` ` `int` `BinarySearchIndexOfMinimumRotatedArray(` `int` `A[], ` `int` `size) ` `{ ` ` ` `return` `BinarySearchIndexOfMinimumRotatedArray(A, 0, size-1); ` `} ` |

*chevron_right*

*filter_none*

See sample test cases http://ideone.com/KbwDrk.

**Exercises:**

1. A function called *signum(x, y)* is defined as,

signum(x, y) = -1 if x < y = 0 if x = y = 1 if x > y

Did you come across any instruction set in which a comparison behaves like *signum* function? Can it make first implementation of binary search optimal?

2. Implement ceil function replica of floor function.

3. Discuss with your friends on “Is binary search optimal (results in least number of comparisons)? Why not ternary search or interpolation search on sorted array? When do you prefer ternary or interpolation search over binary search?”

4. Draw a tree representation of binary search (believe me, it helps you a lot to understand many internals of binary search).

**Stay tuned, I will cover few more interesting problems using binary search in upcoming articles. I welcome your comments.**

– – – by **Venki**. Please write comments if you find anything incorrect, or you want to share more information about the topic discussed above.

Don’t stop now and take your learning to the next level. Learn all the important concepts of Data Structures and Algorithms with the help of the most trusted course: **DSA Self Paced**. Become industry ready at a student-friendly price.

## Recommended Posts:

- Meta Binary Search | One-Sided Binary Search
- Why is Binary Search preferred over Ternary Search?
- Interpolation search vs Binary search
- Linear Search vs Binary Search
- Binary Search
- Binary Search in PHP
- Binary Search in Java
- Uniform Binary Search
- Binary Search using pthread
- Binary Search In JavaScript
- Binary Search a String
- Variants of Binary Search
- Binary Search (bisect) in Python
- Complexity Analysis of Binary Search
- Floor in Binary Search Tree (BST)
- A Problem in Many Binary Search Implementations
- Randomized Binary Search Algorithm
- Binary search in sorted vector of pairs
- Longest Common Prefix using Binary Search
- Binary Search in C++ Standard Template Library (STL)